/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 *
 * @author krug
 */
public class ScribbleCanvas extends Canvas implements MouseListener, MouseMotionListener {

    private Vector points;
    private Vector shapes;
    
    public ScribbleCanvas() {
        super();
        this.addMouseListener(this);
        this.addMouseMotionListener(this);
        
        shapes = new Vector();
        points = new Vector();
    }
    
    public void mouseClicked(MouseEvent arg0) {
    }

    public void mousePressed(MouseEvent arg0) {
        int curX = arg0.getX();
        int curY = arg0.getY();
        
        points.removeAllElements();
        points.add(new ScribblePoint(curX, curY));
   }

    public void mouseReleased(MouseEvent arg0) {
        int curX = arg0.getX();
        int curY = arg0.getY();
        
        points.add(new ScribblePoint(curX, curY));
        if(points.size() > 1)
            shapes.add(new Vector(points)); // copy
        points.removeAllElements();
        
        this.repaint();
    }

    public void mouseEntered(MouseEvent arg0) {
    }

    public void mouseExited(MouseEvent arg0) {
    }

    public void mouseDragged(MouseEvent arg0) {
        int curX = arg0.getX();
        int curY = arg0.getY();
        points.add(new ScribblePoint(curX, curY));
        
        this.repaint();
    }

    public void mouseMoved(MouseEvent arg0) {
    }

    public void clearLastShape() {
        if(shapes.size() >0)
        	shapes.remove(shapes.size() - 1);
        this.repaint();
    }
    
    public void clearAllShapes() {
        shapes.removeAllElements();
        this.repaint();
    }
    
    public void paint(Graphics g) {
       g.setColor(Color.BLACK);
       // frame
        Rectangle frame = this.getBounds();
        g.drawRect(1, 1, (int)frame.getWidth() - 2, (int)frame.getHeight() - 2);
        
        int i, j;
        
        
        // shapes
        for(i = 0 ; i < shapes.size() ; i++) {
            Vector currentShape = (Vector) shapes.get(i);
            for(j = 1 ; j < currentShape.size() ; j++) {
                ScribblePoint a = (ScribblePoint) currentShape.get(j-1);
                ScribblePoint b = (ScribblePoint) currentShape.get(j);
                g.drawLine(a.x, a.y, b.x, b.y);
            }
        }
        
        if(points.size() > 1) {
            for(j = 1 ; j < points.size() ; j++) {
                ScribblePoint a = (ScribblePoint) points.get(j-1);
                ScribblePoint b = (ScribblePoint) points.get(j);
                g.drawLine(a.x, a.y, b.x, b.y);
                
            }
        }
    }
}
